<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cy__crypto__core__des__v1_8c" kind="file" language="C++">
    <compoundname>cy_crypto_core_des_v1.c</compoundname>
    <includes local="yes" refid="cy__crypto__core__des__v1_8h">cy_crypto_core_des_v1.h</includes>
    <includes local="yes" refid="cy__crypto__core__mem__v1_8h">cy_crypto_core_mem_v1.h</includes>
    <includes local="yes" refid="cy__crypto__core__hw__v1_8h">cy_crypto_core_hw_v1.h</includes>
    <includes local="yes" refid="cy__syslib_8h">cy_syslib.h</includes>
    <includes local="no">string.h</includes>
    <incdepgraph>
      <node id="105">
        <label>cy_crypto_core_des_v1.c</label>
        <link refid="cy__crypto__core__des__v1_8c" />
        <childnode refid="106" relation="include">
        </childnode>
      </node>
      <node id="106">
        <label>string.h</label>
      </node>
    </incdepgraph>
    <innerclass prot="public" refid="structcy__stc__crypto__des__buffers__t">cy_stc_crypto_des_buffers_t</innerclass>
      <sectiondef kind="define">
      <memberdef id="cy__crypto__core__des__v1_8c_1ac985b7a04a34a3cdd2504846a143d343" kind="define" prot="public" static="no">
        <name>CY_CRYPTO_DES_WEAK_KEY_COUNT</name>
        <initializer>(16u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_des_v1.c" bodystart="42" column="9" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_des_v1.c" line="42" />
      </memberdef>
      <memberdef id="cy__crypto__core__des__v1_8c_1afb27ed8325a8a4032c492aaad412692a" kind="define" prot="public" static="no">
        <name>CY_CRYPTO_DES_KEY_BYTE_LENGTH</name>
        <initializer>(8u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_des_v1.c" bodystart="43" column="9" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_des_v1.c" line="43" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="enum">
      <memberdef id="cy__crypto__core__des__v1_8c_1a86a45b9dd005a04a52b9d6e50b15bed9" kind="enum" prot="public" static="no">
        <name>cy_en_crypto_des_mode_t</name>
        <enumvalue id="cy__crypto__core__des__v1_8c_1a86a45b9dd005a04a52b9d6e50b15bed9a655d91fc8010f80bc2d773b8025def8f" prot="public">
          <name>CY_CRYPTO_DES_MODE_SINGLE</name>
          <initializer>= 0</initializer>
          <briefdescription>
          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="cy__crypto__core__des__v1_8c_1a86a45b9dd005a04a52b9d6e50b15bed9a867b93295c082ab9361f3edac47bde81" prot="public">
          <name>CY_CRYPTO_DES_MODE_TRIPLE</name>
          <initializer>= 1</initializer>
          <briefdescription>
          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="cy__crypto__core__des__v2_8c_1a86a45b9dd005a04a52b9d6e50b15bed9a655d91fc8010f80bc2d773b8025def8f" prot="public">
          <name>CY_CRYPTO_DES_MODE_SINGLE</name>
          <initializer>= 0</initializer>
          <briefdescription>
          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="cy__crypto__core__des__v2_8c_1a86a45b9dd005a04a52b9d6e50b15bed9a867b93295c082ab9361f3edac47bde81" prot="public">
          <name>CY_CRYPTO_DES_MODE_TRIPLE</name>
          <initializer>= 1</initializer>
          <briefdescription>
          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="56" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_des_v1.c" bodystart="52" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_des_v1.c" line="53" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="var">
      <memberdef id="cy__crypto__core__des__v1_8c_1ac1435497d87e0c1bb48f3fdf6093e844" kind="variable" mutable="no" prot="public" static="yes">
        <type>uint8_t const</type>
        <definition>uint8_t const cy_desWeakKeys[CY_CRYPTO_DES_WEAK_KEY_COUNT][CY_CRYPTO_DES_KEY_BYTE_LENGTH]</definition>
        <argsstring>[CY_CRYPTO_DES_WEAK_KEY_COUNT][CY_CRYPTO_DES_KEY_BYTE_LENGTH]</argsstring>
        <name>cy_desWeakKeys</name>
        <initializer>=
{
    { 0x01u, 0x01u, 0x01u, 0x01u, 0x01u, 0x01u, 0x01u, 0x01u },
    { 0xFEu, 0xFEu, 0xFEu, 0xFEu, 0xFEu, 0xFEu, 0xFEu, 0xFEu },
    { 0x1Fu, 0x1Fu, 0x1Fu, 0x1Fu, 0x0Eu, 0x0Eu, 0x0Eu, 0x0Eu },
    { 0xE0u, 0xE0u, 0xE0u, 0xE0u, 0xF1u, 0xF1u, 0xF1u, 0xF1u },

    { 0x01u, 0x1Fu, 0x01u, 0x1Fu, 0x01u, 0x0Eu, 0x01u, 0x0Eu },
    { 0x1Fu, 0x01u, 0x1Fu, 0x01u, 0x0Eu, 0x01u, 0x0Eu, 0x01u },
    { 0x01u, 0xE0u, 0x01u, 0xE0u, 0x01u, 0xF1u, 0x01u, 0xF1u },
    { 0xE0u, 0x01u, 0xE0u, 0x01u, 0xF1u, 0x01u, 0xF1u, 0x01u },
    { 0x01u, 0xFEu, 0x01u, 0xFEu, 0x01u, 0xFEu, 0x01u, 0xFEu },
    { 0xFEu, 0x01u, 0xFEu, 0x01u, 0xFEu, 0x01u, 0xFEu, 0x01u },
    { 0x1Fu, 0xE0u, 0x1Fu, 0xE0u, 0x0Eu, 0xF1u, 0x0Eu, 0xF1u },
    { 0xE0u, 0x1Fu, 0xE0u, 0x1Fu, 0xF1u, 0x0Eu, 0xF1u, 0x0Eu },
    { 0x1Fu, 0xFEu, 0x1Fu, 0xFEu, 0x0Eu, 0xFEu, 0x0Eu, 0xFEu },
    { 0xFEu, 0x1Fu, 0xFEu, 0x1Fu, 0xFEu, 0x0Eu, 0xFEu, 0x0Eu },
    { 0xE0u, 0xFEu, 0xE0u, 0xFEu, 0xF1u, 0xFEu, 0xF1u, 0xFEu },
    { 0xFEu, 0xE0u, 0xFEu, 0xE0u, 0xFEu, 0xF1u, 0xFEu, 0xF1u }

}</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_des_v1.c" bodystart="60" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_des_v1.c" line="60" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="cy__crypto__core__des__v1_8c_1a003a1689214687ebc839199c18dc7690" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type>void</type>
        <definition>static void Cy_Crypto_Core_V1_Des_ProcessBlock</definition>
        <argsstring>(CRYPTO_Type *base, cy_en_crypto_des_mode_t desMode, cy_en_crypto_dir_mode_t dirMode, uint32_t const *key, uint32_t const *dstBlock, uint32_t const *srcBlock)</argsstring>
        <name>Cy_Crypto_Core_V1_Des_ProcessBlock</name>
        <param>
          <type>CRYPTO_Type *</type>
          <declname>base</declname>
        </param>
        <param>
          <type>cy_en_crypto_des_mode_t</type>
          <declname>desMode</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__crypto__enums_1gae040fb530d4d110976bedfcdb7c8f09c">cy_en_crypto_dir_mode_t</ref></type>
          <declname>dirMode</declname>
        </param>
        <param>
          <type>uint32_t const *</type>
          <declname>key</declname>
        </param>
        <param>
          <type>uint32_t const *</type>
          <declname>dstBlock</declname>
        </param>
        <param>
          <type>uint32_t const *</type>
          <declname>srcBlock</declname>
        </param>
        <briefdescription>
<para>Performs the DES or TDES block cipher. </para>        </briefdescription>
        <detaileddescription>
<para>All addresses must be 4Byte aligned, srcBlock could overlap dstBlock.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>base</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the CRYPTO instance.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>desMode</parametername>
</parameternamelist>
<parameterdescription>
<para>DES cipher operation mode.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>dirMode</parametername>
</parameternamelist>
<parameterdescription>
<para>One of CRYPTO_ENCRYPT or CRYPTO_DECRYPT.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>key</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the encryption/decryption key.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>dstBlock</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the cipher text.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>srcBlock</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the plain text. Must be 4-Byte aligned! </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="144" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_des_v1.c" bodystart="116" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_des_v1.c" line="82" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cy__crypto__core__des__v1_8c_1a0e98fb4c6b5615e664074707e3358ec4" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref></type>
        <definition>cy_en_crypto_status_t Cy_Crypto_Core_V1_Des</definition>
        <argsstring>(CRYPTO_Type *base, cy_en_crypto_dir_mode_t dirMode, uint8_t const *key, uint8_t *dst, uint8_t const *src)</argsstring>
        <name>Cy_Crypto_Core_V1_Des</name>
        <param>
          <type>CRYPTO_Type *</type>
          <declname>base</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__crypto__enums_1gae040fb530d4d110976bedfcdb7c8f09c">cy_en_crypto_dir_mode_t</ref></type>
          <declname>dirMode</declname>
        </param>
        <param>
          <type>uint8_t const *</type>
          <declname>key</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>dst</declname>
        </param>
        <param>
          <type>uint8_t const *</type>
          <declname>src</declname>
        </param>
        <briefdescription>
<para>Performs DES operation on a Single Block. </para>        </briefdescription>
        <detaileddescription>
<para>All addresses must be 4-Byte aligned. Ciphertext (dstBlock) may overlap with plaintext (srcBlock) This function is independent from the previous Crypto state.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>base</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the CRYPTO instance.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>dirMode</parametername>
</parameternamelist>
<parameterdescription>
<para>Can be <ref kindref="member" refid="group__group__crypto__enums_1ggae040fb530d4d110976bedfcdb7c8f09ca4b95ef1e3f73771b0c6a376c6d43e16d">CY_CRYPTO_ENCRYPT</ref> or <ref kindref="member" refid="group__group__crypto__enums_1ggae040fb530d4d110976bedfcdb7c8f09cac7ccc0aa22f73054744e87593deb77fd">CY_CRYPTO_DECRYPT</ref> (<ref kindref="member" refid="group__group__crypto__enums_1gae040fb530d4d110976bedfcdb7c8f09c">cy_en_crypto_dir_mode_t</ref>)</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>key</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the encryption/decryption key.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>dst</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to a destination cipher block.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>src</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to a source block.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref> </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="203" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_des_v1.c" bodystart="174" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_des_v1.c" line="174" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cy__crypto__core__des__v1_8c_1a12b27fd86fe0395f25926e91a24afc09" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref></type>
        <definition>cy_en_crypto_status_t Cy_Crypto_Core_V1_Tdes</definition>
        <argsstring>(CRYPTO_Type *base, cy_en_crypto_dir_mode_t dirMode, uint8_t const *key, uint8_t *dst, uint8_t const *src)</argsstring>
        <name>Cy_Crypto_Core_V1_Tdes</name>
        <param>
          <type>CRYPTO_Type *</type>
          <declname>base</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__crypto__enums_1gae040fb530d4d110976bedfcdb7c8f09c">cy_en_crypto_dir_mode_t</ref></type>
          <declname>dirMode</declname>
        </param>
        <param>
          <type>uint8_t const *</type>
          <declname>key</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>dst</declname>
        </param>
        <param>
          <type>uint8_t const *</type>
          <declname>src</declname>
        </param>
        <briefdescription>
<para>Performs TDES operation on a Single Block. </para>        </briefdescription>
        <detaileddescription>
<para>All addresses must be 4-Byte aligned. Ciphertext (dstBlock) may overlap with plaintext (srcBlock) This function is independent from the previous Crypto state.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>base</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the CRYPTO instance.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>dirMode</parametername>
</parameternamelist>
<parameterdescription>
<para>Can be <ref kindref="member" refid="group__group__crypto__enums_1ggae040fb530d4d110976bedfcdb7c8f09ca4b95ef1e3f73771b0c6a376c6d43e16d">CY_CRYPTO_ENCRYPT</ref> or <ref kindref="member" refid="group__group__crypto__enums_1ggae040fb530d4d110976bedfcdb7c8f09cac7ccc0aa22f73054744e87593deb77fd">CY_CRYPTO_DECRYPT</ref> (<ref kindref="member" refid="group__group__crypto__enums_1gae040fb530d4d110976bedfcdb7c8f09c">cy_en_crypto_dir_mode_t</ref>)</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>key</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the encryption/decryption keys.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>dst</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to a destination cipher block.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>src</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to a source data block.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref> </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="265" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_des_v1.c" bodystart="233" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_des_v1.c" line="233" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>This file provides the source code fro the API for the DES method in the Crypto driver. </para>    </briefdescription>
    <detaileddescription>
<para><simplesect kind="version"><para>2.30.3</para></simplesect>
Copyright 2016-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para><para>Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at</para><para><ulink url="http://www.apache.org/licenses/LICENSE-2.0">http://www.apache.org/licenses/LICENSE-2.0</ulink></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="27"><highlight class="preprocessor">#include<sp />"cy_crypto_core_des_v1.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="28"><highlight class="normal" /></codeline>
<codeline lineno="29"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(CY_IP_MXCRYPTO)</highlight><highlight class="normal" /></codeline>
<codeline lineno="30"><highlight class="normal" /></codeline>
<codeline lineno="31"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="32"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="33"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="34"><highlight class="normal" /></codeline>
<codeline lineno="35"><highlight class="normal" /><highlight class="preprocessor">#if<sp />(CPUSS_CRYPTO_DES<sp />==<sp />1)</highlight><highlight class="normal" /></codeline>
<codeline lineno="36"><highlight class="normal" /></codeline>
<codeline lineno="37"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_crypto_core_mem_v1.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="38"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_crypto_core_hw_v1.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="39"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_syslib.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="40"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;string.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="41"><highlight class="normal" /></codeline>
<codeline lineno="42"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_CRYPTO_DES_WEAK_KEY_COUNT<sp /><sp /><sp />(16u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="43"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_CRYPTO_DES_KEY_BYTE_LENGTH<sp /><sp />(8u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="44"><highlight class="normal" /></codeline>
<codeline lineno="45"><highlight class="normal" /><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal" /></codeline>
<codeline lineno="46"><highlight class="normal">{</highlight></codeline>
<codeline lineno="47"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />block0[CY_CRYPTO_DES_KEY_BYTE_LENGTH<sp />/<sp />4u];</highlight></codeline>
<codeline lineno="48"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />block1[CY_CRYPTO_DES_KEY_BYTE_LENGTH<sp />/<sp />4u];</highlight></codeline>
<codeline lineno="49"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />key[(CY_CRYPTO_DES_KEY_BYTE_LENGTH<sp />/<sp />4u)<sp />*<sp />3u<sp />];</highlight></codeline>
<codeline lineno="50"><highlight class="normal">}<sp />cy_stc_crypto_des_buffers_t;</highlight></codeline>
<codeline lineno="51"><highlight class="normal" /></codeline>
<codeline lineno="52"><highlight class="normal" /><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">enum</highlight><highlight class="normal" /></codeline>
<codeline lineno="53"><highlight class="normal">{</highlight></codeline>
<codeline lineno="54"><highlight class="normal"><sp /><sp /><sp /><sp />CY_CRYPTO_DES_MODE_SINGLE<sp />=<sp />0,</highlight></codeline>
<codeline lineno="55"><highlight class="normal"><sp /><sp /><sp /><sp />CY_CRYPTO_DES_MODE_TRIPLE<sp />=<sp />1</highlight></codeline>
<codeline lineno="56"><highlight class="normal">}<sp />cy_en_crypto_des_mode_t;</highlight></codeline>
<codeline lineno="57"><highlight class="normal" /></codeline>
<codeline lineno="58"><highlight class="normal" /><highlight class="comment">/*<sp />Table<sp />with<sp />DES<sp />weak<sp />keys<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="59"><highlight class="normal">CY_ALIGN(4)</highlight></codeline>
<codeline lineno="60"><highlight class="normal">static<sp />uint8_t<sp />const<sp />cy_desWeakKeys[CY_CRYPTO_DES_WEAK_KEY_COUNT][CY_CRYPTO_DES_KEY_BYTE_LENGTH]<sp />=</highlight></codeline>
<codeline lineno="61"><highlight class="normal">{</highlight></codeline>
<codeline lineno="62"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0x01u,<sp />0x01u,<sp />0x01u,<sp />0x01u,<sp />0x01u,<sp />0x01u,<sp />0x01u,<sp />0x01u<sp />},</highlight></codeline>
<codeline lineno="63"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0xFEu,<sp />0xFEu,<sp />0xFEu,<sp />0xFEu,<sp />0xFEu,<sp />0xFEu,<sp />0xFEu,<sp />0xFEu<sp />},</highlight></codeline>
<codeline lineno="64"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0x1Fu,<sp />0x1Fu,<sp />0x1Fu,<sp />0x1Fu,<sp />0x0Eu,<sp />0x0Eu,<sp />0x0Eu,<sp />0x0Eu<sp />},</highlight></codeline>
<codeline lineno="65"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0xE0u,<sp />0xE0u,<sp />0xE0u,<sp />0xE0u,<sp />0xF1u,<sp />0xF1u,<sp />0xF1u,<sp />0xF1u<sp />},</highlight></codeline>
<codeline lineno="66"><highlight class="normal" /></codeline>
<codeline lineno="67"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0x01u,<sp />0x1Fu,<sp />0x01u,<sp />0x1Fu,<sp />0x01u,<sp />0x0Eu,<sp />0x01u,<sp />0x0Eu<sp />},</highlight></codeline>
<codeline lineno="68"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0x1Fu,<sp />0x01u,<sp />0x1Fu,<sp />0x01u,<sp />0x0Eu,<sp />0x01u,<sp />0x0Eu,<sp />0x01u<sp />},</highlight></codeline>
<codeline lineno="69"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0x01u,<sp />0xE0u,<sp />0x01u,<sp />0xE0u,<sp />0x01u,<sp />0xF1u,<sp />0x01u,<sp />0xF1u<sp />},</highlight></codeline>
<codeline lineno="70"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0xE0u,<sp />0x01u,<sp />0xE0u,<sp />0x01u,<sp />0xF1u,<sp />0x01u,<sp />0xF1u,<sp />0x01u<sp />},</highlight></codeline>
<codeline lineno="71"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0x01u,<sp />0xFEu,<sp />0x01u,<sp />0xFEu,<sp />0x01u,<sp />0xFEu,<sp />0x01u,<sp />0xFEu<sp />},</highlight></codeline>
<codeline lineno="72"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0xFEu,<sp />0x01u,<sp />0xFEu,<sp />0x01u,<sp />0xFEu,<sp />0x01u,<sp />0xFEu,<sp />0x01u<sp />},</highlight></codeline>
<codeline lineno="73"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0x1Fu,<sp />0xE0u,<sp />0x1Fu,<sp />0xE0u,<sp />0x0Eu,<sp />0xF1u,<sp />0x0Eu,<sp />0xF1u<sp />},</highlight></codeline>
<codeline lineno="74"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0xE0u,<sp />0x1Fu,<sp />0xE0u,<sp />0x1Fu,<sp />0xF1u,<sp />0x0Eu,<sp />0xF1u,<sp />0x0Eu<sp />},</highlight></codeline>
<codeline lineno="75"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0x1Fu,<sp />0xFEu,<sp />0x1Fu,<sp />0xFEu,<sp />0x0Eu,<sp />0xFEu,<sp />0x0Eu,<sp />0xFEu<sp />},</highlight></codeline>
<codeline lineno="76"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0xFEu,<sp />0x1Fu,<sp />0xFEu,<sp />0x1Fu,<sp />0xFEu,<sp />0x0Eu,<sp />0xFEu,<sp />0x0Eu<sp />},</highlight></codeline>
<codeline lineno="77"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0xE0u,<sp />0xFEu,<sp />0xE0u,<sp />0xFEu,<sp />0xF1u,<sp />0xFEu,<sp />0xF1u,<sp />0xFEu<sp />},</highlight></codeline>
<codeline lineno="78"><highlight class="normal"><sp /><sp /><sp /><sp />{<sp />0xFEu,<sp />0xE0u,<sp />0xFEu,<sp />0xE0u,<sp />0xFEu,<sp />0xF1u,<sp />0xFEu,<sp />0xF1u<sp />}</highlight></codeline>
<codeline lineno="79"><highlight class="normal" /></codeline>
<codeline lineno="80"><highlight class="normal">};</highlight></codeline>
<codeline lineno="81"><highlight class="normal" /></codeline>
<codeline lineno="82"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />Cy_Crypto_Core_V1_Des_ProcessBlock(CRYPTO_Type<sp />*base,</highlight></codeline>
<codeline lineno="83"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_en_crypto_des_mode_t<sp />desMode,</highlight></codeline>
<codeline lineno="84"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__enums_1gae040fb530d4d110976bedfcdb7c8f09c">cy_en_crypto_dir_mode_t</ref><sp />dirMode,</highlight></codeline>
<codeline lineno="85"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*key,</highlight></codeline>
<codeline lineno="86"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*dstBlock,</highlight></codeline>
<codeline lineno="87"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*srcBlock);</highlight></codeline>
<codeline lineno="88"><highlight class="normal" /></codeline>
<codeline lineno="89"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="90"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_Crypto_Core_V1_Des_ProcessBlock</highlight></codeline>
<codeline lineno="91"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="116"><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />Cy_Crypto_Core_V1_Des_ProcessBlock(CRYPTO_Type<sp />*base,</highlight></codeline>
<codeline lineno="117"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_en_crypto_des_mode_t<sp />desMode,</highlight></codeline>
<codeline lineno="118"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__enums_1gae040fb530d4d110976bedfcdb7c8f09c">cy_en_crypto_dir_mode_t</ref><sp />dirMode,</highlight></codeline>
<codeline lineno="119"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*key,</highlight></codeline>
<codeline lineno="120"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*dstBlock,</highlight></codeline>
<codeline lineno="121"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*srcBlock)</highlight></codeline>
<codeline lineno="122"><highlight class="normal">{</highlight></codeline>
<codeline lineno="123"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />cy_desCommands[2][2]<sp />=<sp />{</highlight></codeline>
<codeline lineno="124"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{<sp />CY_CRYPTO_V1_DES_BLOCK_OPC,<sp /><sp />CY_CRYPTO_V1_DES_BLOCK_INV_OPC<sp /><sp />},<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp /><sp />DES<sp />mode<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="125"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{<sp />CY_CRYPTO_V1_TDES_BLOCK_OPC,<sp />CY_CRYPTO_V1_TDES_BLOCK_INV_OPC<sp />}<sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />TDES<sp />mode<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="126"><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline lineno="127"><highlight class="normal" /></codeline>
<codeline lineno="128"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_SetReg3Instr(base,</highlight></codeline>
<codeline lineno="129"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(uint32_t)key,</highlight></codeline>
<codeline lineno="130"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(uint32_t)srcBlock,</highlight></codeline>
<codeline lineno="131"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(uint32_t)dstBlock);</highlight></codeline>
<codeline lineno="132"><highlight class="normal" /></codeline>
<codeline lineno="133"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Issue<sp />the<sp />DES_BLOCK<sp />instruction<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="134"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Run3ParamInstr(base,</highlight></codeline>
<codeline lineno="135"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_desCommands[(uint8_t)desMode][(uint8_t)dirMode],</highlight></codeline>
<codeline lineno="136"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_RSRC0_SHIFT,</highlight></codeline>
<codeline lineno="137"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_RSRC4_SHIFT,</highlight></codeline>
<codeline lineno="138"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_RSRC8_SHIFT);</highlight></codeline>
<codeline lineno="139"><highlight class="normal" /></codeline>
<codeline lineno="140"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />until<sp />the<sp />AES<sp />instruction<sp />is<sp />complete<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="141"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />(0uL<sp />!=<sp />_FLD2VAL(CRYPTO_STATUS_DES_BUSY,<sp />REG_CRYPTO_STATUS(base)))</highlight></codeline>
<codeline lineno="142"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="143"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="144"><highlight class="normal">}</highlight></codeline>
<codeline lineno="145"><highlight class="normal" /></codeline>
<codeline lineno="146"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="147"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_Crypto_Core_V1_Des</highlight></codeline>
<codeline lineno="148"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="174"><highlight class="normal"><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref><sp />Cy_Crypto_Core_V1_Des(CRYPTO_Type<sp />*base,</highlight></codeline>
<codeline lineno="175"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__enums_1gae040fb530d4d110976bedfcdb7c8f09c">cy_en_crypto_dir_mode_t</ref><sp />dirMode,</highlight></codeline>
<codeline lineno="176"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*key,</highlight></codeline>
<codeline lineno="177"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp />*dst,</highlight></codeline>
<codeline lineno="178"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*src)</highlight></codeline>
<codeline lineno="179"><highlight class="normal">{</highlight></codeline>
<codeline lineno="180"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />i;</highlight></codeline>
<codeline lineno="181"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref><sp />status<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada15d5a5e1314e16c159b7d3fd6f3501b8">CY_CRYPTO_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="182"><highlight class="normal" /></codeline>
<codeline lineno="183"><highlight class="normal"><sp /><sp /><sp /><sp />cy_stc_crypto_des_buffers_t<sp />*desBuffers<sp />=<sp />(cy_stc_crypto_des_buffers_t<sp />*)<ref kindref="member" refid="group__group__crypto__lld__hw__functions_1ga07acf748f85c91a73ad9b8d78a2f70a5">Cy_Crypto_Core_GetVuMemoryAddress</ref>(base);</highlight></codeline>
<codeline lineno="184"><highlight class="normal" /></codeline>
<codeline lineno="185"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />weak<sp />keys<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="186"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(i<sp />=<sp />0U;<sp />(i<sp />&lt;<sp />CY_CRYPTO_DES_WEAK_KEY_COUNT)<sp />&amp;&amp;<sp />(<ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada15d5a5e1314e16c159b7d3fd6f3501b8">CY_CRYPTO_SUCCESS</ref><sp />==<sp />status);<sp />i++)</highlight></codeline>
<codeline lineno="187"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="188"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(Cy_Crypto_Core_V1_MemCmp(base,<sp />key,<sp />(uint8_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*)cy_desWeakKeys[i],<sp />CY_CRYPTO_DES_KEY_BYTE_LENGTH)<sp />==<sp />0U)</highlight></codeline>
<codeline lineno="189"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="190"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />status<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aadafe6a94fc3ef037df88621cb24000f19f">CY_CRYPTO_DES_WEAK_KEY</ref>;</highlight></codeline>
<codeline lineno="191"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="192"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="193"><highlight class="normal" /></codeline>
<codeline lineno="194"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_MemCpy(base,<sp />desBuffers-&gt;key,<sp /><sp /><sp /><sp />key,<sp />CY_CRYPTO_DES_KEY_BYTE_LENGTH);</highlight></codeline>
<codeline lineno="195"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_MemCpy(base,<sp />desBuffers-&gt;block0,<sp />src,<sp />CY_CRYPTO_DES_KEY_BYTE_LENGTH);</highlight></codeline>
<codeline lineno="196"><highlight class="normal" /></codeline>
<codeline lineno="197"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_Des_ProcessBlock(base,<sp />CY_CRYPTO_DES_MODE_SINGLE,<sp />dirMode,</highlight></codeline>
<codeline lineno="198"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(uint32_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*)desBuffers-&gt;key,<sp />(uint32_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*)desBuffers-&gt;block1,<sp />(uint32_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*)desBuffers-&gt;block0);</highlight></codeline>
<codeline lineno="199"><highlight class="normal" /></codeline>
<codeline lineno="200"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_MemCpy(base,<sp />dst,<sp />desBuffers-&gt;block1,<sp />CY_CRYPTO_DES_KEY_BYTE_LENGTH);</highlight></codeline>
<codeline lineno="201"><highlight class="normal" /></codeline>
<codeline lineno="202"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(status);</highlight></codeline>
<codeline lineno="203"><highlight class="normal">}</highlight></codeline>
<codeline lineno="204"><highlight class="normal" /></codeline>
<codeline lineno="205"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="206"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_Crypto_Core_V1_Tdes</highlight></codeline>
<codeline lineno="207"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="233"><highlight class="normal"><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref><sp />Cy_Crypto_Core_V1_Tdes(CRYPTO_Type<sp />*base,</highlight></codeline>
<codeline lineno="234"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__enums_1gae040fb530d4d110976bedfcdb7c8f09c">cy_en_crypto_dir_mode_t</ref><sp />dirMode,</highlight></codeline>
<codeline lineno="235"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*key,</highlight></codeline>
<codeline lineno="236"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp />*dst,</highlight></codeline>
<codeline lineno="237"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*src)</highlight></codeline>
<codeline lineno="238"><highlight class="normal">{</highlight></codeline>
<codeline lineno="239"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />i;</highlight></codeline>
<codeline lineno="240"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref><sp />status<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada15d5a5e1314e16c159b7d3fd6f3501b8">CY_CRYPTO_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="241"><highlight class="normal" /></codeline>
<codeline lineno="242"><highlight class="normal"><sp /><sp /><sp /><sp />cy_stc_crypto_des_buffers_t<sp />*desBuffers<sp />=<sp />(cy_stc_crypto_des_buffers_t<sp />*)<ref kindref="member" refid="group__group__crypto__lld__hw__functions_1ga07acf748f85c91a73ad9b8d78a2f70a5">Cy_Crypto_Core_GetVuMemoryAddress</ref>(base);</highlight></codeline>
<codeline lineno="243"><highlight class="normal" /></codeline>
<codeline lineno="244"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />weak<sp />keys<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="245"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(i<sp />=<sp />0U;<sp />(i<sp />&lt;<sp />CY_CRYPTO_DES_WEAK_KEY_COUNT)<sp />&amp;&amp;<sp />(<ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada15d5a5e1314e16c159b7d3fd6f3501b8">CY_CRYPTO_SUCCESS</ref><sp />==<sp />status);<sp />i++)</highlight></codeline>
<codeline lineno="246"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="247"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(uint32_t<sp />keynum=0U;<sp />(keynum<sp />&lt;<sp />(<ref kindref="member" refid="group__group__crypto__cli__srv__macros_1ga1d31131b7e009e1f0314d6a5e6fc524a">CY_CRYPTO_TDES_KEY_SIZE</ref><sp />/<sp /><ref kindref="member" refid="group__group__crypto__cli__srv__macros_1gab3da4ab588e3a092f75f68534e1f0fe5">CY_CRYPTO_DES_KEY_SIZE</ref>))<sp />&amp;&amp;<sp />(<ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada15d5a5e1314e16c159b7d3fd6f3501b8">CY_CRYPTO_SUCCESS</ref><sp />==<sp />status);<sp />keynum++)</highlight></codeline>
<codeline lineno="248"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="249"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(Cy_Crypto_Core_V1_MemCmp(base,<sp />&amp;(key[keynum<sp />*<sp />CY_CRYPTO_DES_KEY_BYTE_LENGTH]),<sp />(uint8_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*)cy_desWeakKeys[i],<sp />CY_CRYPTO_DES_KEY_BYTE_LENGTH)<sp />==<sp />0U)</highlight></codeline>
<codeline lineno="250"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="251"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />status<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aadafe6a94fc3ef037df88621cb24000f19f">CY_CRYPTO_DES_WEAK_KEY</ref>;</highlight></codeline>
<codeline lineno="252"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="253"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="254"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="255"><highlight class="normal" /></codeline>
<codeline lineno="256"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_MemCpy(base,<sp />desBuffers-&gt;key,<sp /><sp /><sp /><sp />key,<sp />CY_CRYPTO_DES_KEY_BYTE_LENGTH<sp />*<sp />3U);</highlight></codeline>
<codeline lineno="257"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_MemCpy(base,<sp />desBuffers-&gt;block0,<sp />src,<sp />CY_CRYPTO_DES_KEY_BYTE_LENGTH);</highlight></codeline>
<codeline lineno="258"><highlight class="normal" /></codeline>
<codeline lineno="259"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_Des_ProcessBlock(base,<sp />CY_CRYPTO_DES_MODE_TRIPLE,<sp />dirMode,</highlight></codeline>
<codeline lineno="260"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(uint32_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*)desBuffers-&gt;key,<sp />(uint32_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*)desBuffers-&gt;block1,<sp />(uint32_t<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*)desBuffers-&gt;block0);</highlight></codeline>
<codeline lineno="261"><highlight class="normal" /></codeline>
<codeline lineno="262"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_MemCpy(base,<sp />dst,<sp />desBuffers-&gt;block1,<sp />CY_CRYPTO_DES_KEY_BYTE_LENGTH);</highlight></codeline>
<codeline lineno="263"><highlight class="normal" /></codeline>
<codeline lineno="264"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(status);</highlight></codeline>
<codeline lineno="265"><highlight class="normal">}</highlight></codeline>
<codeline lineno="266"><highlight class="normal" /></codeline>
<codeline lineno="267"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />#if<sp />(CPUSS_CRYPTO_DES<sp />==<sp />1)<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="268"><highlight class="normal" /></codeline>
<codeline lineno="269"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="270"><highlight class="normal">}</highlight></codeline>
<codeline lineno="271"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="272"><highlight class="normal" /></codeline>
<codeline lineno="273"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXCRYPTO<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="274"><highlight class="normal" /></codeline>
<codeline lineno="275"><highlight class="normal" /></codeline>
<codeline lineno="276"><highlight class="normal" /><highlight class="comment">/*<sp />[]<sp />END<sp />OF<sp />FILE<sp />*/</highlight><highlight class="normal" /></codeline>
    </programlisting>
    <location file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_des_v1.c" />
  </compounddef>
</doxygen>